/* TestResource.java
 * Test of the DEMOS style resource using Example 3 (p55) of
 * Discrete Event Modelling on Simula - by GM Birtwistle
 */

import eduni.simjava.*;

class Reader extends Sim_entity {
  Resource file;
  double delay;

  public Reader(String name, Resource file, double start_delay) {
    super(name);
    this.file = file;
    delay = start_delay;
  }

  public void body() {
    //System.out.println("-- Reader starting");
    sim_hold(delay);
    // Run till the end time of the sim
    while(Sim_system.clock() < TestResource.simlength) {
      // Read the info
      file.acquire(1);
      sim_hold(2.0);
      file.release(1);
      // Use the info
      sim_hold(5.0);
    }
  }
}

class Writer extends Sim_entity {
  Resource file;
  double delay;

  public Writer(String name, Resource file, double start_delay) {
    super(name);
    this.file = file;
    delay = start_delay;
  }

  public void body() {
    //System.out.println("-- Writer starting");
    sim_hold(delay);
    // Run till the end time of the sim
    while(Sim_system.clock() < TestResource.simlength) {
      // Gather the info
      sim_hold(5.0);
      // Write the info
      file.acquire(3);
      sim_hold(3.0);
      file.release(3);
    }
  }
}

public class TestResource {
  public final static double simlength = 25.0; // The run length of the sim

  public static void main(String args[]) {
    Resource file;

    Sim_system.initialise();
    Sim_system.set_auto_trace(false);
    file = new Resource("File", 3);
    Sim_system.add(file);
    Sim_system.add(new Reader("Reader1", file, 0.0));
    Sim_system.add(new Writer("Writer1", file, 0.0));
    Sim_system.add(new Reader("Reader2", file, 0.0));
    Sim_system.add(new Reader("Reader3", file, 2.0));
    Sim_system.add(new Writer("Writer2", file, 1.0));
    Sim_system.run();
  }
}
