package cache;


import java.applet.*;
import java.awt.*;
import eduni.simanim.*;
import eduni.simjava.*;
import eduni.simdiag.*;

class Cpu extends Sim_entity {
  private Sim_port io;
  private int requests, num_requests;
  private Sim_uniform_obj addr;

  public Cpu(String name, int requests, int x, int y) {
    super(name, "cpu", x, y);
    io = new Sim_port("io", "port", Anim_port.BOTTOM, 10); add_port(io);
    this.requests = requests;
    addr = new Sim_uniform_obj("Addresses", 0, 16, (int)System.currentTimeMillis());
    num_requests = 0;
    add_param(new Anim_param("Requests", Anim_param.NAME_VALUE, "0", 36, 20));
  }

  public void body() {
    int i;
    int address;

    for(i=0; i<requests; i++) {
      address = (int)addr.sample();
      sim_schedule(io, 0.0, address);  // Request a memory address
      sim_trace(1, "S io "+address);
      num_requests++;
      sim_trace(1, "P "+num_requests);
      sim_wait(null);                  // Wait for it to come back
      sim_hold(0.01);
    }
  }
}
