
package workfarm;

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import eduni.simanim.*;
import eduni.simjava.*;
import eduni.simdiag.*;

// The Work router
public class Wrouter extends Sim_entity {
  private Sim_port worker, next, in;
  private int state;

  private static final int FORWARD = 0;
  private static final int COLLECT = 1;

  public Wrouter(String name, int x, int y) {
    super(name, "wrouter", x, y);
    worker = new Sim_port("worker", "port", Anim_port.BOTTOM, 10); add_port(worker);
    next = new Sim_port("next", "port", Anim_port.RIGHT, 10); add_port(next);
    in = new Sim_port("in", "port", Anim_port.LEFT, 10); add_port(in);
    state = COLLECT;
    add_param(new Anim_param("State", Anim_param.STATE, "collect"));
  }

  public void body() {
    Sim_event ev = new Sim_event();
    while(true) {
      sim_get_next(ev);
      sim_hold(0.01);
      if(ev.get_tag() == 1) {
        if(state == COLLECT) {
          sim_schedule(worker, 0.0, 1);
          if(GraphTest.show_msg) sim_trace(1, "S worker W");
          state = FORWARD; dump_state();
        } else {
          sim_schedule(next, 0.0, 1);
          if(GraphTest.show_msg) sim_trace(1, "S next W");
        }
      } else {
        state = COLLECT; dump_state();
      }
    }
  }

  public void dump_state() {
    if(state == FORWARD) sim_trace(1, "P forward");
    if(state == COLLECT) sim_trace(1, "P collect");
  }
}
