package omega;

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import eduni.simanim.*;
import eduni.simjava.*;

// Src generates messages
public class Src extends Sim_entity {
  private Sim_port out;
  private double delay;
  private int max;
  private int srcnum;
  private int nsrcs;
  private int workload;

  public Src(String name, int x, int y, int srcnum, int nsrcs, int max, 
	     double delay, int workload) {
    super(name,"src",x,y);
    out = new Sim_port("out", "port", Anim_port.RIGHT, 2); add_port(out);
    this.max   = max;
    this.delay = delay;
    this.srcnum = srcnum;
    this.nsrcs = nsrcs;
    this.workload = workload;
  }

  void send(int dest, double hold_time) {
    sim_schedule(out, 0.0, 1, new Integer(dest));
    if (Omega.show_msg) sim_trace(1, "S out "+dest);   
    sim_hold(hold_time);		 
  }

  public void body() {
    int i;
    
    if (workload == 0) { // 1 to all
      if (srcnum==1) {
	for(i=0; i<max; i++) {
	  send(i % nsrcs,delay);
	}    
      }
    } else if (workload==1) { // all to 1
      for(i=0; i<max; i++) {
	send(1,delay);
      }    
    } else if (workload==2) { // all to all
      for(i=0; i<max; i++) {
	send((i+srcnum) % nsrcs,delay);
      }    
    } else { // random 
      Random rdest = new Random();
      double spacing = 
	(workload==3) ? 10.0 : 
	(workload==4) ? 1.0 : 0.0;
      Sim_normal_obj rdelay = new Sim_normal_obj("Delay Object", 
						 spacing, spacing/2, srcnum);
      for(i=0; i<max; i++) {
	send(rdest.nextInt() % nsrcs, rdelay.sample());
      }    
    } 
  }
}
