package omega;

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import eduni.simanim.*;
import eduni.simjava.*;

// Network switch 
public class Sw extends Sim_entity {
  private Sim_port in1, in2, out1, out2;
  private double hold;
  private int state;
  private int swsize;
  private int destp;

  private static final int STRAIGHT = 0;
  private static final int CROSS    = 1;


  public Sw( String name, int x, int y, int swsize, double hold) {
    super(name,"sw",x,y);
    this.hold = hold;
    this.swsize = swsize;
    in1 = new Sim_port( "in1","port", Anim_port.LEFT, 2); add_port(in1);
    in2 = new Sim_port( "in2","port", Anim_port.LEFT, 8); add_port(in2);
    out1 = new Sim_port( "out1","port", Anim_port.RIGHT, 2); add_port(out1);
    out2 = new Sim_port( "out2","port", Anim_port.RIGHT, 8); add_port(out2);
  
    state = STRAIGHT;
    add_param(new Anim_param("State", Anim_param.STATE, "straight"));
    add_param(new Anim_param("Destp", Anim_param.VALUE, "0", -10, -10));
  }

  public void body() {
    dump_state();

    int destport = 1;

    while (true) {
      Sim_event ev = new Sim_event();

      // Get event:-
      sim_get_next(ev);

      destp = ((Integer)ev.get_data()).intValue();


      // System.out.println(get_name() + " Got " + destp);
      // Route message:- message destination is
      // 010
      // dud
      destp <<= 1;
      int mask = swsize; // 1 bit per stage
      if ((destp & mask)==0) { destport = 1; } else {destport = 2;}

      // Determine switch state
      int srcport = 1;
      if (ev.scheduled_by() == in1.get_dest()) 
	{ srcport = 1; } else { srcport = 2; }
      if (srcport == destport) { state = STRAIGHT;} else {state=CROSS;}
 
      dump_state();
      sim_hold(hold); 
      if (destport==1) {
	sim_schedule(out1, 0.0, 1, new Integer(destp));
      } else {
	sim_schedule(out2, 0.0, 1, new Integer(destp));
      }
      if (Omega.show_msg) 
	sim_trace(1, "S out"+destport+" "+destp);     // Send on result
    }
  }

  public void dump_state() {
    if(state == STRAIGHT) sim_trace(1, "P straight "+destp);
    if(state == CROSS) sim_trace(1, "P cross "+destp);
  }
}
 
